<?php
 /**
  * @version   $Id$
  * @author    RocketTheme http://www.rockettheme.com
  * @copyright Copyright (C) 2007 - 2011 RocketTheme, LLC
  * @license   http://www.gnu.org/licenses/gpl-2.0.html GNU/GPLv2 only
  */
 class JElementColorChooser extends JElement {


	function fetchElement($name, $value, &$node, $control_name)
	{
		global $stylesList;
		$output = '';
		$document 	=& JFactory::getDocument();

		if (!defined('MOORAINBOW')) {
            $option = 'com_rokgallery';
			$document->addStyleSheet('components/'.$option.'/assets/moorainbow/mooRainbow.css');
			$document->addScript('components/'.$option.'/assets/moorainbow/mooRainbow'.$this->_getJSVersion().'.js');

			$scriptconfig = $this->rainbowInit();

			$document->addScriptDeclaration($scriptconfig);

			define('MOORAINBOW',1);
		}

		$transparent = 1;
		if ($node->attributes('transparent') == 'false') $transparent = 0;
		
		$scriptconfig = $this->newRainbow($name, $transparent);

		$document->addScriptDeclaration($scriptconfig);

		$output .= "<input class=\"picker-input text-color\" id=\"".$control_name.$name."\" name=\"".$control_name."[".$name."]\" type=\"text\" size=\"10\" maxlength=\"11\" value=\"".$value."\" />";
		$output .= "<div class=\"picker\" id=\"myRainbow_".$name."_input\"><div class=\"overlay".(($value == 'transparent') ? ' overlay-transparent' : '')."\" style=\"background-color: ".$value."\"><div></div></div></div>\n";
		$output .= "</div>";

		return $output;
	}

	function newRainbow($name, $transparent)
	{
        $option = "com_rokgallery";

        $name2 = str_replace("-", "_", $name);

		$mt = (strlen($this->_getJSVersion())) ? false : true;
		$dollar = $mt ? "$" : "document.id";
		$getValue = $mt ? "getValue()" : "get('value')";

		return "
		var r_".$name2.";
		window.addEvent('domready', function() {
			".$dollar."('params".$name."').getParent().addEvents({
				'mouseenter': f_".$name2.",
				'mouseleave': function(){
					this.removeEvent('mouseenter', f_".$name2.");
				}
			});
		});

		var f_".$name2." = function(){
			var input = ".$dollar."('params".$name."');
			r_".$name2." = new MooRainbow('myRainbow_".$name."_input', {
				id: 'myRainbow_".$name."',
				startColor: ".$dollar."('params".$name."').".$getValue.".hexToRgb(true) || [255, 255, 255],
				imgPath: 'components/".$option."/assets/moorainbow/images/',
				transparent: ".$transparent.",
				onChange: function(color) {
					if (color == 'transparent') {
						input.getNext().getFirst().addClass('overlay-transparent').setStyle('background-color', 'transparent');
						input.value = 'transparent';
					}
					else {
						input.getNext().getFirst().removeClass('overlay-transparent').setStyle('background-color', color.hex);
						input.value = color.hex;
					}
					
					if (this.visible) this.okButton.focus();
				}
			});	
			
			r_".$name2.".okButton.setStyle('outline', 'none');
			".$dollar."('myRainbow_".$name."_input').addEvent('click', function() {
				(function() {r_".$name2.".okButton.focus()}).delay(10);
			});
			input.addEvent('keyup', function(e) {
				if (e) e = new Event(e);
				if ((this.value.length == 4 || this.value.length == 7) && this.value[0] == '#') {
					var rgb = new Color(this.value);
					var hex = this.value;
					var hsb = rgb.rgbToHsb();
					var color = {
						'hex': hex,
						'rgb': rgb,
						'hsb': hsb
					}
					r_".$name2.".fireEvent('onChange', color);
					r_".$name2.".manualSet(color.rgb);
				};
			});

			input.getNext().getFirst().setStyle('background-color', r_".$name2.".sets.hex);
			rainbowLoad('myRainbow_".$name."');
		};\n";
	}

	function rainbowInit()
	{
		$mt = (strlen($this->_getJSVersion())) ? false : true;
		$dollar = $mt ? "$" : "document.id";
		$getValue = $mt ? "getValue()" : "get('value')";
		
		return "var rainbowLoad = function(name, hex) {
				if (hex) {
					var n = name.replace('params', '');
					".$dollar."(n+'_input').getPrevious().value = hex;
					".$dollar."(n+'_input').getFirst().setStyle('background-color', hex);
				}
			};
		";
	}

	function _getJSVersion() {
		if (version_compare(JVERSION, '1.5', '>=') && version_compare(JVERSION, '1.6', '<')){
			if (JPluginHelper::isEnabled('system', 'mtupgrade')){
				return "-mt1.2";
			} else {
				return "";
			}
		} else {
			return "";
		}
	}
}

?>