<?php
 /**
  * @version   $Id$
  * @author    RocketTheme http://www.rockettheme.com
  * @copyright Copyright (C) 2007 - 2011 RocketTheme, LLC
  * @license   http://www.gnu.org/licenses/gpl-2.0.html GNU/GPLv2 only
  */

class RokCommon_Memory
{
    /**
     * Gets the current memory limit set for the php.ini in bytes
     * @static
     * @return int the memory limit in bytes
     */
    public static function getLimit()
    {
        $val = ini_get('memory_limit');
        $val = trim($val);
        $last = strtolower($val[strlen($val) - 1]);
        switch ($last)
        {
            // The 'G' modifier is available since PHP 5.1.0
            case 'g':
                $val *= 1024;
            case 'm':
                $val *= 1024;
            case 'k':
                $val *= 1024;
        }

        return $val;
    }

    /**
     * Gets the available free space in bytes
     *
     * @static
     * @return int
     */
    public static function getFreeSpace()
    {
        return self::getLimit() - self::getUsage();
    }


    /**
     * @param $size the mem_limit size
     */
    public static function setLimit($size)
    {
        ini_set('memory_limit', $size);
    }

    public static function getUsage()
    {
        return memory_get_usage();
    }
}
