<?php
/**
* @version		$Id: gallery.php 39662 2011-07-07 06:50:52Z djamil $
* @package		Joomla
* @copyright	Copyright (C) 2005 - 2010 Open Source Matters. All rights reserved.
* @license		GNU/GPL, see LICENSE.php
* Joomla! is free software. This version may have been modified pursuant
* to the GNU General Public License, and as distributed it includes or
* is derivative of works licensed under the GNU General Public License or
* other free or open source software licenses.
* See COPYRIGHT.php for copyright notices and details.
*/

// Check to ensure this file is included in Joomla!
defined('_JEXEC') or die( 'Restricted access' );

class JElementGallery extends JElement
{

    protected static $js_loaded = false;

    public function __construct($parent = null)
    {
        $include_file = realpath(JPATH_SITE . '/components/com_rokgallery/include.php');
        $included_files = get_included_files();
        if (!in_array($include_file, $included_files) && ($libret = require_once($include_file)) !== 'JOOMLA_ROKGALLERY_LIB_INCLUDED') {
            JError::raiseWarning(100, 'RokGallery: ' . implode('<br /> - ', $loaderrors));
            return;
        }
        parent::__construct($parent);
    }

	/**
	 * Element name
	 *
	 * @access	protected
	 * @var		string
	 */
	var	$_name = 'Gallery';

	function fetchElement($name, $value, &$node, $control_name)
	{
		global $mainframe;

		//$db			=& JFactory::getDBO();
		$doc 		=& JFactory::getDocument();
		$template 	= $mainframe->getTemplate();
		$fieldName	= $control_name.'['.$name.']';
		//$article =& JTable::getInstance('content');
		//if ($value) {
		//	$article->load($value);
		//} else {
		//	$article->title = JText::_('Select a Gallery');
		//}

		$js = "
		var RokGalleryPopup = RokGalleryID = null;
		var RokGalleryFixed = 0;
		window.addEvent('domready', function(){
			var mooVersion = MooTools.version;
			if (RokGalleryPopup) return;
			
			RokGalleryPopup = $('gallery-popup');
			RokGalleryID = $('".$name."_id');
			var titles = ['#title' , 'input[name=name]', '#jform_title', '#jform_title'],
				title = '',
				href = RokGalleryPopup.getAttribute('href');
			
			titles.each(function(selector){
				var element = $$(selector)[0]; if (element) title = element;
			});
			
			RokGalleryPopup.addEvent('mouseenter', function(){
				RokGalleryUpdateTitle(title, href);
			});
			
		});
		
		function RokGalleryUpdateTitle(title, href){
			title = title.getValue() || '';
			var args = '&id=' + RokGalleryID.getValue() + '&name=' + title + '&fixed=' + RokGalleryFixed + '&cache=' +(new Date().getTime());
			RokGalleryPopup.setProperty('href', href + args);
		};";
        if (!self::$js_loaded){
		    $doc->addScriptDeclaration($js);
            self::$js_loaded = true;
        }

		$link = 'index.php?option=com_rokgallery&view=gallerymanager&tmpl=component';



		JHTML::_('behavior.modal', 'a.modal');

        $gallery_name = '';
        if (!empty($value)){
            $gallery = RokGallery_Model_GalleryTable::getSingle((int)$value);
            if ($gallery === false) {
                $value = null;
            }
            else {
                $gallery_name = $gallery->name;
            }
        }
		$html = "\n".'<div style="float: left;"><input style="background: #ffffff;" type="text" id="'.$name.'_name" value="'.htmlspecialchars($gallery_name, ENT_QUOTES, 'UTF-8').'" disabled="disabled" /></div>';
//		$html .= "\n &nbsp; <input class=\"inputbox modal-button\" type=\"button\" value=\"".JText::_('Select')."\" />";
		$html .= '<div class="button2-left"><div class="blank"><a id="gallery-popup" class="modal" title="'.JText::_('Select a Gallery').'"  href="'.$link.'" rel="{handler: \'iframe\', size: {x: 420, y: 495}}">'.JText::_('Select').'</a></div></div>'."\n";
		$html .= "\n".'<input type="hidden" id="'.$name.'_id" name="'.$fieldName.'" value="'.$value.'" />';

		return $html;
	}
}