<?php
 /**
  * @version   $Id: SliceFilter.php 39525 2011-07-05 18:58:14Z btowles $
  * @author    RocketTheme http://www.rockettheme.com
  * @copyright Copyright (C) 2007 - 2011 RocketTheme, LLC
  * @license   http://www.gnu.org/licenses/gpl-2.0.html GNU/GPLv2 only
  */

class RokGallery_Model_SliceFilter extends RokCommon_Doctrine_Filter
{
    protected function _getThumbPath(RokGallery_Model_Slice $record)
    {
        $root = RokGallery_Config::getOption(RokGallery_Config::OPTION_ROOT_PATH);
        $path = $root . $record->getRelativeThumbPath(DS);
        return $path;
    }

    protected function _getThumbUrl($record)
    {
        $root = RokGallery_Config::getOption(RokGallery_Config::OPTION_THUMBNAIL_BASE_URL);
        $path = $root . $record->getRelativeThumbPath('/');
        return $path;
    }

    protected function _getAdminThumbPath(RokGallery_Model_Slice $record)
    {
        $root = RokGallery_Config::getOption(RokGallery_Config::OPTION_ROOT_PATH);
        $path = $root . $record->getRelativeThumbPath(DS,'admin-thumb');
        return $path;
    }

    protected function _getAdminThumbUrl($record)
    {
        $root = RokGallery_Config::getOption(RokGallery_Config::OPTION_THUMBNAIL_BASE_URL);
        $path = $root . $record->getRelativeThumbPath('/','admin-thumb');
        return $path;
    }

    protected function _getImageUrl($record)
    {
        $root = RokGallery_Config::getOption(RokGallery_Config::OPTION_BASE_URL);
        $path = $root . $record->getRelativePath('/');
        return $path;
    }

    protected function _getDoILove($record){
        return RokCommon_Session::get('com_rokgallery.site.loves.file_'.$record->file_id,false);
    }
}
